using System;
using System.Data;
using System.Configuration;
using System.Collections;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;
using System.Xml;
using System.Net;
using System.IO;
using System.Text;

public partial class Controls_USPSShipmentRates : System.Web.UI.UserControl
{
    protected void Page_Load(object sender, EventArgs e)
    {

    }

	public void DisplayData(string xmlString)
	{
		// Remove all items in the drop down menu.
		drpdRates.Items.Clear();
		string _xmlData = xmlString;
		if (_xmlData == "E")
		{
			lblErrMsg.Text = "An error occured while connecting to USPS server. Please check your internet connection and try again";
		}
		else
		{
			XmlDocument xmlDoc = new XmlDocument();
			XmlElement root;
			xmlDoc.LoadXml(_xmlData);
			root = xmlDoc.DocumentElement;
			string firstNodeName = root.FirstChild.Name.ToString();
			if (firstNodeName == "Number")
			{
				pnlServices.Visible = false;
				string errNumber = root.SelectSingleNode("//Number").InnerText;
				string errSource = root.SelectSingleNode("//Source").InnerText;
				string errDescription = root.SelectSingleNode("//Description").InnerText;
				lblErrMsg.Text = errDescription;
			}
			else
			{
				pnlServices.Visible = true;
				XmlNodeList nodes = xmlDoc.SelectNodes("//Postage");

				StringBuilder sb = new StringBuilder("<Postage>");
				foreach (XmlNode n in nodes)
					sb.Append(n.OuterXml);
				sb.Append("</Postage>");

				XmlNodeReader reader = null;
				//re-load the xml document without the error attribute 
				xmlDoc.LoadXml(sb.ToString());
				reader = new XmlNodeReader(xmlDoc);

				// Create a dataset to hold the result
				DataSet ds = new DataSet();
				ds.ReadXml(reader);

				// Populate the dropdownlist with the values
				drpdRates.Items.Add(new ListItem("Select service", "-1"));
				foreach (DataTable table in ds.Tables)
				{
					foreach (DataRow row in table.Rows)
					{
						drpdRates.Items.Add(new ListItem(row["MailService"].ToString() + " $" + row["Rate"].ToString(), row["Rate"].ToString()));
					}
				}
			}
		}
	}
	protected void btnSubmitRequest_Click(object sender, EventArgs e)
	{
		if (drpdContainerType.Items.FindByValue("-1").Selected || drpdPackageSize.Items.FindByValue("-1").Selected || drpdSerivce.Items.FindByValue("-1").Selected)
		{
			lblErrMsg.Text = "Please select all required options and try again.";
		}
		else
		{
			lblErrMsg.Text = string.Empty;
			string _xmlResponse;
			USPS.USPSRates _uspsRates = new USPS.USPSRates();
			if (chkbxMachinable.Checked)
			{
				_uspsRates.machinable = true;
			}
			else
			{
				_uspsRates.machinable = false;
			}
			_uspsRates.packageSize = drpdPackageSize.SelectedItem.Value;
			_uspsRates.pounds = int.Parse(txtWeightPounds.Text);
			_uspsRates.ounces = int.Parse(txtWeightOunces.Text);
			_uspsRates.shipService = drpdSerivce.SelectedItem.Value;
			_uspsRates.packageId = 0;
			_uspsRates.containerType = drpdContainerType.SelectedItem.Value;
			_uspsRates.zipOrigination = txtOriginZipCode.Text;
			_uspsRates.zipDestination = txtDestinationZipCode.Text;
			_xmlResponse = _uspsRates.RequestUSPSRates();
			DisplayData(_xmlResponse);
		}
	}
}
